*cd \workingdirectory\ /**<- Change this to the directory of the raw data file **/

cd "/Users/evanstarr/Documents/Locked In LEHD?/JHR Accepted/Replication/Replication Inputs/QWI_setup.do"
/**/
insheet using "All_State_QWI_Data_2011_2017.csv", clear
label data "version: QWISE_F MT 30 1993:1-2017:1 V4.1.3 R2017Q4 qwipu_mt_20171116_1120"
drop version
compress
save QWI_raw, replace 
**/
use QWI_raw, clear
/** geography labels are from LED documentation here: https://lehd.ces.census.gov/data/schema/latest/label_fipsnum.csv 
**/
label drop _all

label define geography 1 "Alabama"
label define geography 2 "Alaska", add
label define geography 4 "Arizona", add
label define geography 5 "Arkansas", add
label define geography 6 "California", add
label define geography 8 "Colorado", add
label define geography 9 "Connecticut", add
label define geography 10 "Delaware", add
label define geography 11 "District of Columbia", add
label define geography 12 "Florida", add
label define geography 13 "Georgia", add
label define geography 15 "Hawaii", add
label define geography 16 "Idaho", add
label define geography 17 "Illinois", add
label define geography 18 "Indiana", add
label define geography 19 "Iowa", add
label define geography 20 "Kansas", add
label define geography 21 "Kentucky", add
label define geography 22 "Louisiana", add
label define geography 23 "Maine", add
label define geography 24 "Maryland", add
label define geography 25 "Massachusetts", add
label define geography 26 "Michigan", add
label define geography 27 "Minnesota", add
label define geography 28 "Mississippi", add
label define geography 29 "Missouri", add
label define geography 30 "Montana", add
label define geography 31 "Nebraska", add
label define geography 32 "Nevada", add
label define geography 33 "New Hampshire", add
label define geography 34 "New Jersey", add
label define geography  35 "New Mexico", add
label define geography 36 "New York", add
label define geography 37 "North Carolina", add
label define geography 38 "North Dakota", add
label define geography 39 "Ohio", add
label define geography 40 "Oklahoma", add
label define geography 41 "Oregon", add
label define geography 42 "Pennsylvania", add
label define geography 44 "Rhode Island", add
label define geography 45 "South Carolina", add
label define geography 46 "South Dakota", add
label define geography 47 "Tennessee", add
label define geography 48 "Texas", add
label define geography 49 "Utah", add
label define geography 50 "Vermont", add
label define geography 51 "Virginia", add
label define geography 53 "Washington", add
label define geography 54 "West Virginia", add
label define geography 55 "Wisconsin", add
label define geography 56 "Wyoming", add
label values geography geography


/* Labels from https://lehd.ces.census.gov/data/schema/latest/label_education.csv */
egen edcode=group(education)
replace edcode=edcode-1
label define education 0 "All Education Categories"
label define education 1 "Less than high school", add
label define education 2 "High school or equivalent, no college", add
label define education 3 "Some college or Associate degree", add
label define education 4 "Bachelor's degree or advanced degree", add
label define education 5 "Educational attainment not available (workers aged 24 or younger)", add
label values edcode education 


label define flag -2 "no data available in this category for this quarter"
label define flag -1 "data not available to compute this estimate", add
label define flag 1 "OK", add
label define flag 5 "Value suppressed because it does not meet US Census Bureau publication standards.", add
label define flag 6 "Value calculated from other released measures - no significant distortion", add
label define flag 7 "Value calculated from other released measures - some of which have significantly distorted data", add
label define flag 9 "Data significantly distorted - fuzzed value released", add
label define flag 10 "Aggregate of cells - no significant distortion", add
label define flag 11 "Aggregate of cells not released because component cells do not meet U.S. Census Bureau publication standards", add
label define flag 12 "Aggregate of cells - some of which have significantly distorted data", add

label define gender 0 "All Sexes"
label define gender 1 "Male", add
label define gender 2 "Female", add
label values sex gender

gen agecode=substr(agegrp, 3, 1)
destring agecode, replace
label define agel 0 "All Ages (14-99)"
label define agel 1 "14-18", add
label define agel 2 "19-21", add
label define agel 3 "22-24", add
label define agel 4 "25-34", add
label define agel 5 "35-44", add
label define agel 6 "45-54", add
label define agel 7 "55-64", add
label define agel 8 "65-99", add
label values agecode agel


label define fage 0 "All Firm Ages"
label define fage 1 "0-1 Years", add
label define fage 2 "2-3 Years", add
label define fage 3 "4-5 Years", add
label define fage 4 "6-10 Years", add
label define fage 5 "11+ Years", add
*label define fage N "Firm Age Not Available For Public-Sector Firms", add
label values firmage fage
tab firmage

label define fsize 0 "All Firm Sizes"
label define fsize 1 "0-19 Employees", add
label define fsize 2 "20-49 Employees", add
label define fsize 3 "50-249 Employees", add
label define fsize 4 "250-499 Employees", add
label define fsize 5 "500+ Employees", add
*label define fsize N "Firm Size Not Available For Public-Sector Firms", add
label values firmsize fsize


gen ocode=substr(ownercode,3,1)
destring ocode, replace
label define ownl  0 "State and local government plus private ownership"
label define ownl  1 "Federal government", add
label define ownl  5 "All Private", add
label values ocode ownl

gen ethcode=substr(ethnicity,2,1)
destring ethcode, replace
label define ethcode 0 "All Ethnicities"
label define ethcode 1 "Not Hispanic or Latino", add
label define ethcode 2 "Hispanic or Latino", add
label values ethcode ethcode

label define qtr 1 "1st Quarter of the Year (January-March)"
label define qtr 2 "2nd Quarter of the Year (April-June)", add
label define qtr 3 "3rd Quarter of the Year (July-September)", add
label define qtr 4 "4th Quarter of the Year (October-December)", add
label values quarter qtr

gen racecode=substr(race,2,1)
destring racecode, replace
label define rcode 0 "All Races"
label define rcode 1 "White Alone", add
label define rcode 2 "Black or African American Alone", add
label define rcode 3 "American Indian or Alaska Native Alone", add
label define rcode 4 "Asian Alone", add
label define rcode 5 "Native Hawaiian or Other Pacific Islander Alone", add
label define rcode 6 "Some Other Race Alone (Not Used)", add
label define rcode 7 "Two or More Race Groups", add
label values racecode rcode

label var year "Year"
label var sex "Sex (0=Both genders)"
label var agegrp "Age groups (A00=All)" 
label var agecode "Age groups, Numeric " 
label var firmage "Firm Age groups (0=All)" 
label var firmsize "Firm Size groups (0=All)" 
label var ownercode "Ownercode (A00=All)" 
label var ocode "Ownercode, Numeric" 
label var ethnicity "Ethnicity (A0=All)" 
label var periodicity "A=Annual data, Q=Quarterly data" 
label var quarter "Quarter"
label var race "Race (A0=All)"
label var ind_level "Industry Level (4=NAICS Industry Groups)"
label var geo_level "Geographic Level (S=States)"
label var industry "4-digit NAICS Code"
label var education "Education groups (0=All)"  
label var geography "Statecodes"  

gen statecode=geography
label var statecode "State code (=geography)"

label var season "Seasonally adjusted (U=Unadjusted)"  
label var emp "Beginning-of-Quarter Employment"
label var empend "End-of-Quarter Employment"
label var emps "Full-Quarter Employment (Stable)"
label var empspv "Full-Quarter Employment in the Previous Quarter"
label var emptotal "Employment - Reference Quarter"
label var hira "Hires (All Accessions)"
label var hirn "New Hires"
label var hirr "Recall Hires"
label var sep "Separations (All)"
label var hiraend "End-of-Quarter Hires"
label var hiraendr "End-of-Quarter Hiring Rate"
label var sepbeg "Beginning-of-Quarter Separations"
label var sepbegr "Beginning-of-Quarter Separation Rate"
label var hiras "Hires (All Hires into Full-Quarter Employment)"
label var hirns "New Hires (New Hires into Full-Quarter Employment)"
label var seps "Separations (Flows out of Full-Quarter Employment)"
label var sepsnx "Separations in the Next Quarter (Flows out of Full-Quarter Employment)"
label var turnovrs "Turnover (Stable)"
label var frmjbgn "Firm Job Gains (Job Creation)"
label var frmjbls "Firm Job Loss (Job Destruction)"
label var frmjbc "Firm Job Change (Net Change)"
label var hiraendrepl "Replacement Hires"
label var hiraendreplr "Replacement Hiring Rate"
label var frmjbgns "Firm Job Gains (Stable)"
label var frmjblss "Firm Job Loss (Stable)"
label var frmjbcs "Firm Job Change (Stable; Net Change)"
label var earns "Average Monthly Earnings (Full-Quarter Employment)"
label var earnbeg "Average Monthly Earnings (Beginning-of-Quarter Employment)"
label var earnhiras "Average Monthly Earnings (All Hires into Full-Quarter Employment)"
label var earnhirns "Average Monthly Earnings (New Hires into Full-Quarter Employment)"
label var earnseps "Average Monthly Earnings (Flows out of Full-Quarter Employment)"
label var payroll "Total Quarterly Payroll"
label var semp "Flag for Beginning-of-Quarter Employment"
label var sempend "Flag for End-of-Quarter Employment"
label var semps "Flag for Full-Quarter Employment (Stable)"
label var sempspv "Flag for Full-Quarter Employment in the Previous Quarter"
label var semptotal "Flag for Employment - Reference Quarter"
label var shira "Flag for Hires (All Accessions)"
label var shirn "Flag for New Hires"
label var shirr "Flag for Recall Hires"
label var ssep "Flag for Separations (All)"
label var shiraend "Flag for End-of-Quarter Hires"
label var shiraendr "Flag for End-of-Quarter Hiring Rate"
label var ssepbeg "Flag for Beginning-of-Quarter Separations"
label var ssepbegr "Flag for Beginning-of-Quarter Separation Rate"
label var shiras "Flag for Hires (All Hires into Full-Quarter Employment)"
label var shirns "Flag for New Hires (New Hires into Full-Quarter Employment)"
label var sseps "Flag for Separations (Flows out of Full-Quarter Employment)"
label var ssepsnx "Flag for Separations in the Next Quarter (Flows out of Full-Quarter Employment)"
label var sturnovrs "Flag for Turnover (Stable)"
label var sfrmjbgn "Flag for Firm Job Gains (Job Creation)"
label var sfrmjbls "Flag for Firm Job Loss (Job Destruction)"
label var sfrmjbc "Flag for Firm Job Change (Net Change)"
label var shiraendrepl "Flag for Replacement Hires"
label var shiraendreplr "Flag for Replacement Hiring Rate"
label var sfrmjbgns "Flag for Firm Job Gains (Stable)"
label var sfrmjblss "Flag for Firm Job Loss (Stable)"
label var sfrmjbcs "Flag for Firm Job Change (Stable; Net Change)"
label var searns "Flag for Average Monthly Earnings (Full-Quarter Employment)"
label var searnbeg "Flag for Average Monthly Earnings (Beginning-of-Quarter Employment)"
label var searnhiras "Flag for Average Monthly Earnings (All Hires into Full-Quarter Employment)"
label var searnhirns "Flag for Average Monthly Earnings (New Hires into Full-Quarter Employment)"
label var searnseps "Flag for Average Monthly Earnings (Flows out of Full-Quarter Employment)"
label var spayroll "Flag for Total Quarterly Payroll"

foreach var in semp-spayroll{
label values `var' flag
}

gen double yrqtr=yq(year, quarter)

gen tech=0
*** Computer manufacturing + semi-conductors

replace tech=1 if industry==3341
*334111 Electronic Computer Manufacturing
*replace tech=1 if ind==334112	//Computer Storage Device Manufacturing
*replace tech=1 if ind==334118	//Computer Terminal and Other Computer Peripheral Equipment Manufacturing
replace tech=1 if industry==3342
*replace tech=1 if ind==334220	//Radio and Television Broadcasting and Wireless Communications Equipment Manufacturing
*replace tech=1 if ind==334290	//Other Communications Equipment Manufacturing
replace tech=1 if industry==3343
*replace tech=1 if ind==334310	//Audio and Video Equipment Manufacturing
replace tech=1 if industry==3344
*replace tech=1 if ind==334413	//Semiconductor and Related Device Manufacturing
*replace tech=1 if ind==334416	//Capacitor, Resistor, Coil, Transformer, and Other Inductor Manufacturing
*replace tech=1 if ind==334417	//Electronic Connector Manufacturing
*replace tech=1 if ind==334418	//Printed Circuit Assembly (Electronic Assembly) Manufacturing
*replace tech=1 if ind==334419	//Other Electronic Component Manufacturing
** IT Industries per the BLS https://www.bls.gov/opub/btn/volume-2/pdf/careers-in-growing-field-of-information-technology-services.pdf
replace tech=1 if industry==5112	
replace tech=1 if industry==5182 
replace tech=1 if industry==5415	
/*
replace tech=1 if ind==511210	//Software Publishers
replace tech=1 if ind==518210   //Data Processing, Hosting, and Related Services 6695
replace tech=1 if ind==541511	//Custom Computer Programming Services
replace tech=1 if ind==541512	//Computer Systems Design Services
replace tech=1 if ind==541513	//Computer Facilities Management Services
replace tech=1 if ind==541519	//Other Computer Related Services
*/
gen hi=(geography==15)
drop if geography ==11 /** Dropping District of Columbia **/

sort statecode
merge m:1 statecode using temp_nc
drop _m
gen fc_hi_diff=abs(FC09_ml- -.1672194)
egen tag_st=tag(statecode)
egen dfhi_temp=rank(fc_hi_diff) if tag_st==1, track
egen dfhi=max(dfhi_temp) , by(statecode)
drop dfhi_temp fc_hi_diff
label var dfhi "Pre-Ban Ranked Absolute Difference Between Hawaii Enforceability"

gen sepr=sep/emptotal
label var sepr "Separation Rate (All Separations to Total Employment)"
compress

gen post=yrqtr>=222
gen srpost=(yrqtr>=222 & yrqtr<=225)
gen lrpost=(yrqtr>225)
gen i2d=int(industry/100)
egen Tech2d=max(tech), by(i2d)
gen All=1 
gen w=emp
global wagevar earns earnhiras earnhirns  earnseps
foreach xx in $wagevar  {
gen ln_`xx' =log(`xx')
local lab: variable label `xx'
label var ln_`xx' "Log `lab' "
}
gen sepsnxr=sepsnx/(0.5*(emp+empend))
label var sepsnxr "Seperation Rate (From Full Qtr Emp)"
ren ind_level ilevel

gen dfhi40=(dfhi<=40)
gen dfhi50=1

keep if yrqtr>=213 //* keeping only 2013 q2 onwards **/
gen None=1
gen EmpWgt=w
gen ln_emp=log(emp)
gen ln_emptotal=log(emptotal)
gen ln_emps=log(emps)
label var ln_emp "Log Beginning-of-Quarter Employment"
label var ln_emptotal "Log Employment-Reference Quarter"
label var ln_emps "Log Full Quarter Employment (Stable)"

egen stateyrqtr=group(statecode yrqtr)
egen stateind=group(statecode industry)
egen indyrqtr=group(industry yrqtr)

egen stateXtech=group(statecode tech)

save temp_qwi_fin, replace




